set include=\c700\mfc\include;\c700\include
set lib=\c700\lib;\c700\mfc\lib
@echo off
echo.

if "%1" == "debug" goto l_debug
if "%1" == "retail" goto l_retail
if "%1" == "clean" goto l_clean

:l_help
	echo.
	echo.
	echo Welcome to the Microsoft Foundation Classes/Dr. Dobb's 
	echo           Handwriting Browser Application
	echo ------------------------------------------------------
	echo.
	echo Usage:
	echo.
	echo.
	echo	build debug 	- includes debug information (bigger and slower)
	echo	build retail 	- lean and mean version
	echo	build clean 	- prepare for full rebuild
	echo.
	echo.
	echo Note: Building HWB requires Microsoft C/C++ 7.0, MFC, 
	echo small model Windows libraries, Windows import libraries,
	echo and commdlg.dll.  Be sure that CL.EXE is on your PATH.
	echo.
	goto l_done:


:l_retail
	echo Building lean and mean version of MFC HWB.EXE
	@echo on
	cl /GA /G2 /DWINVER=0x0300 /Oxzs /Gs /W3 /c hwb.cpp
	cl /GA /G2 /DWINVER=0x0300 /Oxzs /Gs /W3 /c hwx.c
	link /NOD /ONERROR:NOEXE /ALIGN:4 hwb.obj hwx.obj, hwb, NUL, safxcw libw slibcew commdlg, hwb.def;
	rc /30 /t /k hwb_r.res hwb.exe
	@echo off
	goto l_done:


:l_debug
	echo Building diagnostic version of MFC HWB.EXE
	echo on
	cl /D_DEBUG /GA /G2 /DWINVER=0x0300 /Od /W4 /Zi /c hwb.cpp
	cl /D_DEBUG /GA /G2 /DWINVER=0x0300 /Od /W3 /Zi /c hwx.c
	link /NOD /ONERROR:NOEXE /ALIGN:4 /COD hwb.obj hwx.obj, hwb, NUL, safxcwd libw slibcew commdlg, hwb.def;
	rc /30 /t /k hwb_d.res hwb.exe
	@echo off
	goto l_done:


:l_clean
	echo Cleaning things up...
	echo.
	del *.obj
	del *.exe
	del *.res
	del *.map
	@echo off
	goto l_done


:l_done
	echo.
	echo Questions or problems?  Please FAX them to the AFX group:
	echo 	Steven Sinofsky
	echo 	Microsoft Corporation, Building 17W
	echo		(206) 93 MSFAX (fax)
	echo.
