/*-------------------------------------------------------------*\
 | CharView.H -- General include file for CharView.Exe.        |
\*-------------------------------------------------------------*/
#define PRIVATE static
#define PUBLIC
#define MAX_CHARS 256
#define FILE_SIGNATURE (0x2121)
#define INT16 int
#define MAX_INSTANCE (20)

typedef void *GenericT;
typedef struct tagList
{
    INT16      num_items;
    GenericT items[1]; 
}  List;
typedef List FAR * LPLIST;
typedef LPLIST FAR * LPLPLIST;

/*-----------------File.Open Dialog Definitions----------------*/
const int MAXFILENAME = 80;

/*-------------------Public File I/O Routines------------------*/
PUBLIC  void  file_LoadHWXData(LPCSTR name);
PUBLIC  void  file_UnloadHWXData(void);
PUBLIC  void  FatalError(char* msg);

/*--------------Public Memory Management Routines--------------*/
PUBLIC void * mem_Alloc(size_t num_bytes);
PUBLIC void * mem_Realloc(void *v,size_t num_bytes);
PUBLIC void   mem_Free(void far *);
PUBLIC void   mem_AllocFailed(size_t n);
PUBLIC void   mem_Err(void);
PUBLIC void   mem_CheckHeap(void);
PUBLIC void * mem_CAlloc(size_t,size_t);

/*------------------Resource File Definitions------------------*/
#define IDR_MAINMENU     1

#define IDM_FILE_OPEN    100
#define IDM_FILE_PRINT   101
#define IDM_FILE_EXIT    102

#define IDM_VIEW_LETTER  200

#define IDM_SCALE_100    300
#define IDM_SCALE_75     301
#define IDM_SCALE_50     302

#define IDC_LISTBOX       50 //Listbox window id.

/*-----------------Marker Drawing Definitions------------------*/
const int MARKERSIZE = 2;

/*------------------Mouse Arg Parsing Macros-------------------*/
#define MOUSEX(arg) (arg.LP.Lo)
#define MOUSEY(arg) (arg.LP.Hi)

/*-------------------------------------------------------------*\
 |                    Function Prototypes.                     |
\*-------------------------------------------------------------*/
void DrawMarker (HDC hDC, int x, int y);

#define ASSERT {if (CharData[1] != (LPLIST)NULL) { _asm { int 3  }}}
#define FIRST_CHAR (0x021)
