/*-------------------------------------------------------------*\
 |  CLASSES.H -- Class declarations for CharView.EXE.          |
\*-------------------------------------------------------------*/
class TCVApplication : public TApplication
  {
  public:
    TCVApplication (LPSTR lpszName, HINSTANCE hInstance,
                     HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
                     int nCmdShow);
    virtual void InitMainWindow ();
  };

_CLASSDEF (TMainWindow)
_CLASSDEF (TCharViewWindow)

/*-------------------------------------------------------------*/
class TMainWindow : public TWindow
  {
  public:
    TMainWindow (PTWindowsObject pwParent, LPSTR lpszTitle,
                PTModule pmModule);
    ~TMainWindow();
    virtual LPSTR GetClassName ();
    int GetListboxHeight() {return cyLBHeight;};
    virtual void  SetupWindow ();
    virtual void  GetWindowClass (WNDCLASS&);
    virtual void  WMActivate(TMessage& Msg) = [WM_FIRST + WM_ACTIVATE];
    virtual void  WMSize (TMessage &Msg) = [WM_FIRST + WM_SIZE];
    virtual void  CmdListboxNotify(TMessage& Msg) =
                                     [ID_FIRST + IDC_LISTBOX];
    virtual void  CmdFileOpen(TMessage& Msg) =
                                       [CM_FIRST + IDM_FILE_OPEN];
    virtual void  CmdScale100(TMessage& Msg) =
                                     [CM_FIRST + IDM_SCALE_100];
    virtual void  CmdScale75(TMessage& Msg) =
                                     [CM_FIRST + IDM_SCALE_75];
    virtual void  CmdScale50(TMessage& Msg) =
                                     [CM_FIRST + IDM_SCALE_50];
    PTCharViewWindow ptLeft;
  private:
    HWND             hwndList;
    int              cyLBHeight;
    PTCharViewWindow ptRight;
  };

/*-------------------------------------------------------------*/
class TCharViewWindow : public TWindow
  {
  public:
    TCharViewWindow (PTWindowsObject pwParent, LPSTR lpszTitle,
                     PTModule pmModule, int iScaling,
                     int iRows, int iColumns, int iInstStart,
                     int iInstEnd, int iListBox);
    ~TCharViewWindow();
    virtual void  Paint(HDC hdc, PAINTSTRUCT &ps);
    void SetCurrentChar (BYTE chNew);
    void SetScalingFactor (int iScaling);
    void SelectCharacter  (BYTE ch, int instStart, int instEnd);
    virtual LPSTR GetClassName ();
    virtual void  GetWindowClass (WNDCLASS&);
    virtual void  WMLButtonDown(TMessage& Msg) = [WM_LBUTTONDOWN];
  private:
    BOOL bDrawComplete;
    BYTE chCurrent;
    HPEN hpenLetter;
    HPEN hpenTextCell;
    HPEN hpenBoundBox;
    HPEN hpenCurrent;
    int  cRows;
    int  cColumns;
    int  instFirst;
    int  instLast;
    int  instCurrent;
    int  cxMargin;
    int  cyMargin;
    int  cxCell;
    int  cyCell;
    int  cyListBox;
    RECT rHitTest[20];
  };

/*-------------------------------------------------------------*/
