/****************************************************************
CLIENT.H -- Header file for CLIENT.C
****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h> 
#include <nit.h>
#include <time.h>

#ifndef ENGINE_DEFINES
#define ENGINE_DEFINES

#define ENGINE_SOCKET         0x0099
#define INIT_SOCKET           0x0090
#define ENGINE_TYPE           0x88

#define ADD_RECORD            0x02
#define FIND_RECORD_KEY       0x03
#define FIND_RECORD_NO_KEY    0xf4
#define READ_RECORD           0xf5        
#define EDIT_RECORD           0xf6
#define DELETE_RECORD         0x07

#define NUMBER_OF_NODES 4

#define win(l, t, r, b, a) window((l), (t), (r), (b)); \
            textattr((a)); clrscr();

typedef struct ipxheader {
    WORD checkSum;
    WORD length;
    BYTE transportControl;
    BYTE packetType;
    LONG destNet;
    BYTE destNode[6];
    WORD destSocket;
    LONG sourceNet;
    BYTE sourceNode[6];
    WORD sourceSocket;
} IPX_HEADER;

typedef struct fragment {
    void far *fragAddress;
    WORD fragSize;
} ECBFragment;

typedef struct ecb {
    void far *linkAddress;
    void far *ESRAddress;
    BYTE inUseFlag;
    BYTE completionCode;
    WORD socket;
    BYTE IPXWorkspace[4];
    BYTE driverWorkspace[12];
    BYTE immediateAddress[6];
    WORD fragCount;
    ECBFragment fragList[2];
} IPX_ECB;

typedef struct engineInfo {
    int occupied;
    char dataFile[256];
    char serverName[49];
    BYTE engineAddress[12];
    WORD serverType;
} INFO;

typedef struct recordHeader {
    unsigned long status;
    unsigned long offset;
    unsigned long hashkey;
    unsigned long recordNumber;
    unsigned long transactionNumber;
    unsigned char key[128];
} rHeader;

typedef struct recordData {
    time_t creationTime;
    time_t lastReferenceTime;
    time_t lastUpdateTime;
    unsigned char nodeAddress[10];    /* node address of last updater */
    unsigned long objectID;                /* object ID of last updater */
    unsigned char data[128];
} rData;

typedef struct record {
    rHeader header;
    rData data;
} rec;

typedef struct shortPacket {
    WORD responseCode;
    BYTE operation;
    rHeader header;
} sPacket;

typedef struct longPacket {
    WORD responseCode;
    BYTE operation;
    rec record;
} lPacket;

typedef struct initPacket {
    char dataFilePath[_MAX_PATH];
} iPacket;

#endif
