/****************************************************************
ENGINE.H  -- Header file for Engine.C -- by Michael Day 6/26/92
****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <process.h>
#include <nwsemaph.h>
#include <nwipxspx.h>
#include <nwtypes.h>
#include <nwdir.h>
#include <nwmisc.h>
#include <io.h>
#include <nwtts.h>
#include <advanced.h>
#include <string.h> 
#include <direct.h>
#include <errno.h>
#include <signal.h>

#ifndef ENGINE_DEFINES
#define ENGINE_DEFINES

#define ENGINE_SOCKET       0x0099
#define INIT_SOCKET         0x0090
#define ENGINE_TYPE         0x88

#define ADD_RECORD          0x02
#define FIND_RECORD_KEY     0x03
#define FIND_RECORD_NO_KEY  0xf4
#define READ_RECORD         0xf5        
#define EDIT_RECORD         0xf6
#define DELETE_RECORD       0x07

typedef struct recordHeader {
    unsigned long status;
    unsigned long offset;
    unsigned long hashkey;
    unsigned long recordNumber;
    unsigned long transactionNumber;
    unsigned char key[128];
} rHeader;                        /* hex size of 0x94 */

typedef struct recordData {
    time_t   creationTime;
    time_t   lastReferenceTime;
    time_t   lastUpdateTime;
    unsigned char nodeAddress[10];    /* node address of last updater */
    unsigned long objectID;                /* object ID of last updater */
    unsigned char data[128];    /* hex size of 0x9a */
} rData;

typedef struct record {
    rHeader header;
    rData data;
} rec;

typedef struct shortPacket {
    WORD responseCode;
    BYTE operation;
    rHeader header;
} sPacket;

typedef struct longPacket {
    WORD responseCode;
    BYTE operation;
    rec record;
} lPacket;

typedef struct initPacket {
    char dataFilePath[_MAX_PATH];
} iPacket;

typedef struct opnode {
    IPX_HEADER packetHeader;
    lPacket packet;
} ENGINE_OP_NODE;

#endif
