#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CImageBox: self draw drop-down list for multiple images

class CHwbDlg;
class CImageBox : public CComboBox
{
public:
	CHwbDlg* m_pParent;

// Implementation
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
};

/////////////////////////////////////////////////////////////////////////////
// CHwbDlg:
//   The main user interface to this application is a dialog

class CHwbDlg : public CModalDialog
{
// Constructors
public:
	CHwbDlg();
	~CHwbDlg();

// Attributes
	// global state of browser
	COLORREF m_colorCur;
	int		m_nLineWidth;

	// current state (based on selection in .DAT file)
	BOOL	m_bLoaded;		// .DAT file loaded
	char	m_chCur;		// current character
	int		m_nInstanceCount; // number of instance of this character
	int		m_iInstanceCur;	// current instance of that character

// Operations
	void RenderInstance(CDC* pDC, char ch, int iInstance,
			CRect rect, int inflate, BOOL bAttrib);

// Implementation
	CImageBox		m_charBox;	// all possible characters

protected:
	// brushes for drawing
	CBrush			m_brBack, m_brGray;
	CFont			m_statusFont;

	// special controls
	CBitmapButton	m_buttons[NUM_BITMAPBUTTONS];
	CImageBox		m_imageBox;		// image selection
	CStatic			m_display;		// display output control
	CScrollBar		m_scrollBar;

	CRect GetOutputRect();

	// message handlers
	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar*);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);

	// command handlers
	afx_msg void OnOpen();
	afx_msg void OnCopy();
	afx_msg void OnPrint();
	afx_msg void OnAbout();
	afx_msg void OnPrevChar();
	afx_msg void OnNextChar();
	afx_msg void OnLineColor();

	// control notification handlers
	afx_msg	void OnInstanceSelect();
	afx_msg	void OnCharSelect();

#ifdef _DEBUG
	afx_msg void OnShowStrokes();
#endif
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CHwbApp: all MFC applications have a single application class

class CHwbApp : public CWinApp
{
public:
	CHwbApp() : CWinApp("MFC HandWriting Browser")
		{ }

	BOOL InitInstance();
};
