#ifndef  __HWXBROWZ_H
#define  __HWXBROWZ_H

#include <dir.h>
#include <owl.h>
#include <scrollba.h>
#include <static.h>

_CLASSDEF( TMainWindow )
_CLASSDEF( TMainApp )

#include "gridview.h"
#include "viewwind.h"
#include "printer.h"
#include "h_file.h"
#include "drawdata.h"


class TMainWindow : public TDialog
{
        BOOL  fDataLoaded;
        char  lpszFileName[ MAXPATH ];

        //
        // Cursor Handle used when setting the
        // Hour Hourglass cursor
        //
        HCURSOR hCurSave;

        PTGridWindow GridWindow;
        PTViewWindow ViewWindow;
        PTPrinter    Printer;
        PTScrollBar  ScaleScrollBar;
        PTStatic     ScaleText;

        //
        // the following structure will be shared by all the
        // views displaying characters
        //
        TDrawData DrawData;
    public:
        TMainWindow( PTWindowsObject, LPSTR, PTModule AModule = NULL );
        virtual ~TMainWindow();
        virtual LPSTR GetClassName();
        virtual void  GetWindowClass( WNDCLASS& );
        virtual void  SetupWindow();

        BOOL IsData(){  return( fDataLoaded );  }

        void SetCurChar( int ch, int inst );

        void UpdateSubViews( void );
        void EnableScaleScrollBar( BOOL );


        virtual void CMExit    ( RTMessage ) = [ CM_FIRST + CM_EXIT ];
        virtual void CMFileRead( RTMessage ) = [ CM_FIRST + CM_READ ];
        virtual void CMPrint( RTMessage )    = [ CM_FIRST + CM_PRINT ];
        virtual void CMPrinterSetup( RTMessage)=[CM_FIRST + CM_PRINTERSETUP];
        virtual void CMAbout( RTMessage )    = [ CM_FIRST + CM_ABOUT ];


        virtual void IDForColor ( RTMessage ) = [ ID_FIRST + ID_FORCOLOR ];
        virtual void IDBackColor( RTMessage ) = [ ID_FIRST + ID_BACKCOLOR ];
        virtual void IDLineRad1 ( RTMessage ) = [ ID_FIRST + ID_LINERAD1 ];
        virtual void IDLineRad2 ( RTMessage ) = [ ID_FIRST + ID_LINERAD2 ];
        virtual void IDLineRad3 ( RTMessage ) = [ ID_FIRST + ID_LINERAD3 ];
        virtual void IDLineRad4 ( RTMessage ) = [ ID_FIRST + ID_LINERAD4 ];
        virtual void IDScrollScale(RTMessage) = [ ID_FIRST + ID_SCROLLSCALE ];

        void  SetWait( void );
        void  ReleaseWait( void );
};



class TMainApp : public TApplication
{
    public:
        TMainApp( LPSTR AName, HINSTANCE hInstance, 
                  HINSTANCE hPrevInstance,
                  LPSTR lpCmd, int nCmdShow);
        virtual void InitMainWindow();
};



#endif   // __HWXBROWZ_H
