#ifndef  __H_FILE_H
#define  __H_FILE_H


// defines used by h_file.c

#define PRIVATE         static
#define PUBLIC
#define MAX_CHARS       128
#define FILE_SIGNATURE (0x2121)
#define INT16           int
#define MAX_INSTANCE   (20)

// data structure

#ifndef __GENCLASS
#define __GENCLASS
typedef void *GenericT;
typedef struct tagList
{
    INT16      num_items;
    GenericT items[1];
}  List;
typedef List    * LPLIST;
typedef LPLIST  * LPLPLIST;

#endif

/*-------------------Public File I/O Routines------------------*/
// returns 1 if file read succeeded, else 0
PUBLIC  int   file_LoadHWXData(char *name); 

PUBLIC  void  file_UnloadHWXData(void);
PUBLIC  void  FatalError(char* msg);

/*--------------Public Memory Management Routines--------------*/
PUBLIC void * mem_Alloc(size_t num_bytes);
PUBLIC void * mem_Realloc(void *v,size_t num_bytes);
PUBLIC void   mem_Free(void *);
PUBLIC void   mem_AllocFailed(size_t n);
PUBLIC void   mem_Err(void);
PUBLIC void   mem_CheckHeap(void);
// DELETE PUBLIC void * mem_CAlloc(size_t,size_t);

#define ASSERT {if (CharData[1] != (LPLIST)NULL) { _asm { int 3  }}}
#define FIRST_CHAR (0x021)


/* --- functions for accessing the character data which has ---- */
/* --- been read in --- */

LPLIST  GetCharInstanceData( int ch, int index );
LPLIST  GetInstanceStroke( int ch , int inst_index, int stroke_inst );
LPPOINT GetFirstPoint( LPLIST lpStroke );


#endif   // __H_FILE_H
