/****************************************************************
| H_MEM.C  -- memory allocation module
+****************************************************************/

#include "h_config.h"

#define PUBLIC
#define PRIVATE static

#ifdef TURBO_C
#include <stdio.h>
#include <alloc.h>
#endif

#include <Windows.H>

extern char chErrBuf[];
void  FatalError(char* msg);
/****************************************************************/
PRIVATE long num_operations = 0;
PRIVATE long bytes_allocd = 0;
/****************************************************************/
PUBLIC void *mem_Realloc(void *v,size_t num_bytes)
{
#ifdef MS_DOS
    num_operations++;
    return realloc(v,num_bytes);
#endif
}
/****************************************************************/
PUBLIC void mem_Free(void far *v)
{
#ifdef MS_DOS
    num_operations++;
    free(v);  /*free it anyway*/
#endif
}
/****************************************************************/
PUBLIC void * mem_Alloc(size_t num_bytes)
{
#ifdef MS_DOS
    void *v = malloc(num_bytes);
    bytes_allocd += num_bytes;
    num_operations++;
    return v;
#endif
}
/****************************************************************/
PUBLIC void * mem_CAlloc(size_t num_items, size_t item_size)
{
#ifdef MS_DOS
    void *v = calloc(num_items, item_size);
    long num_bytes = (long)(num_items * item_size);
    bytes_allocd += num_bytes;
    num_operations++;
    return v;
#endif
}
/****************************************************************/
PUBLIC void mem_AllocFailed(size_t num_bytes)
{
#ifdef MS_DOS
    wsprintf (chErrBuf, "***Mem alloc #%ld failed on %ld bytes***",
		(long)num_operations,(long)num_bytes);

    FatalError (chErrBuf);
#endif
}
