#include <owl.h>
#include <windowsx.h>
#include <stdio.h>


#include "ids.h"
#include "viewwind.h"
#include "hwxbrowz.h"
#include "showdraw.h"



//
//  Constructor of ViewWindow - Store pointer to DrawData
//
TViewWindow::TViewWindow( PTWindowsObject p , int id , PTDrawData pd ) : 
TControl( p , id)
{
    pDrawData = pd;
}


//
//  Handles WM_ERASEBKGND messages...
//
void TViewWindow::WMEraseBkgnd( RTMessage msg )
{
    HDC hdc = (HDC)msg.WParam;
    RECT rect;
    GetClientRect( HWindow , &rect );

    HBRUSH hb = CreateSolidBrush( pDrawData->rgbBackGroundColor );
    UnrealizeObject( hb );

    FillRect( hdc , &rect , hb );
    DeleteObject( hb );
    msg.Result = TRUE;
}



//
//  Returns ViewWindow's Class Name
//
LPSTR TViewWindow::GetClassName()
{
    return "VIEWWINDOW";
}


//
//  OWL encapsulation of the WM_PAINT Message...
//
void  TViewWindow::Paint( HDC hdc , PAINTSTRUCT _FAR & )
{
    if ((( PTMainWindow )Parent)->IsData() )
    {
        RECT rect;
        HPEN hpenNew = CreatePen( PS_SOLID , pDrawData->nLineThickness ,
                                             pDrawData->rgbLineColor );
        HPEN hpenOld = SelectPen( hdc , hpenNew );

        GetClientRect( HWindow, &rect );
        rect.top     += 2 + pDrawData->nLineThickness / 2;
        rect.left    += 2 + pDrawData->nLineThickness / 2;
        rect.bottom  -= 2 + pDrawData->nLineThickness / 2;
        rect.right   -= 2 + pDrawData->nLineThickness / 2;

        DrawCharLines( hdc , rect, pDrawData->cur_char , pDrawData->cur_inst  );
        SelectPen( hdc , hpenOld );
        DeletePen( hpenNew );
    }
}
 
